# NOTE: You should create a feature request or bug report before coding a PR
**Did you create a bug report or feature request first?**

**Is this a feature or bug fix?**

**Does this PR align with the core project principles?**
Project principles are available [HERE](
  https://github.com/stargateaudio/stargate/docs/project_design_principles.md
)

If not, provide a justification for why we should implement it anyway.  We
listen to our users, but we have an obligation to the same users and future
users to maintain a project vision and align new features to that vision, and
not become a bloated, incoherent mess of random features glued together.

**Briefly describe what the PR does, how much value it adds, and why**

**How did you test the code for bugs and performance?**

**How does it affect resource consumption such as CPU, GPU and RAM?**
Will it negatively affect the ability of the software to run on a Raspberry Pi
or 10 year old laptop?  If so, describe the steps already taken to optimize
this feature, and alternatives considered (if any), and why you did not choose
an alternative.

